package cn.iocoder.yudao.module.pms.service.yanfan.devicetemplate;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.devicetemplate.vo.IotYfDeviceTemplatePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.devicetemplate.vo.IotYfDeviceTemplateSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.devicetemplate.IotYfDeviceTemplateDO;
import cn.iocoder.yudao.module.pms.dal.mysql.yanfan.devicetemplate.IotYfDeviceTemplateMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import javax.annotation.Resource;

import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * yf设备采集点模板关联对象 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotYfDeviceTemplateServiceImpl implements IotYfDeviceTemplateService {

    @Resource
    private IotYfDeviceTemplateMapper iotYfDeviceTemplateMapper;

    @Override
    public IotYfDeviceTemplateDO selectDeviceTemplateByProduct(Long productId) {
        List<IotYfDeviceTemplateDO> productId1 = iotYfDeviceTemplateMapper.selectList("product_id", productId);
        if (CollUtil.isNotEmpty(productId1)) {
            throw new ServiceException(new ErrorCode(1,"不存在模板"));
        }
        return productId1.get(0);
    }

    @Override
    public Long createIotDeviceTemplate(IotYfDeviceTemplateSaveReqVO createReqVO) {
        // 插入
        IotYfDeviceTemplateDO iotDeviceTemplate = BeanUtils.toBean(createReqVO, IotYfDeviceTemplateDO.class);
        iotYfDeviceTemplateMapper.insert(iotDeviceTemplate);
        // 返回
        return iotDeviceTemplate.getId();
    }

    @Override
    public void updateIotDeviceTemplate(IotYfDeviceTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeviceTemplateExists(updateReqVO.getId());
        // 更新
        IotYfDeviceTemplateDO updateObj = BeanUtils.toBean(updateReqVO, IotYfDeviceTemplateDO.class);
        iotYfDeviceTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeviceTemplate(Long id) {
        // 校验存在
        validateIotDeviceTemplateExists(id);
        // 删除
        iotYfDeviceTemplateMapper.deleteById(id);
    }

    private void validateIotDeviceTemplateExists(Long id) {
        if (iotYfDeviceTemplateMapper.selectById(id) == null) {
            throw exception(new ErrorCode(222,"不存在设备模板"));
        }
    }

    @Override
    public IotYfDeviceTemplateDO getIotDeviceTemplate(Long id) {
        return iotYfDeviceTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<IotYfDeviceTemplateDO> getIotDeviceTemplatePage(IotYfDeviceTemplatePageReqVO pageReqVO) {
        return iotYfDeviceTemplateMapper.selectPage(pageReqVO);
    }

}
